/* chiamata_a_funzione.c */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>


/*	serve per GENERARE CODICE ASSEMBLY CON IL COMANDO
		gcc -ansi -S -masm=intel  chiamata_a_funzione.c

 	E FAR VEDERE::
	
	- cosa viene caricato sullo stack quando si chiama una funzione.
		- return value, parametri formali, dynamic linking, variabili locali.
	- come viene modificato il BP.
	- come si accede alle variabili locali.
		- offset rispetto a BP.
	- come si accede alle variabili globali.
		- offset rispetto a inizio segmento.
	- come si esce dalla funzione.
		- come si rimettono a posto i valori di SP, BP e Instruction Pointer.
 */


int sum=99;


static int Chiamata (int a)
{
	int x;

	x = sum;
	x += a;
	a = x;

	return x;
}


int Chiamante (int a, int b)
{
	int y=4;

	y = Chiamata(a);
	y += 1;

	sum = y;
	
	return y;
}
